
%%%%%%%%%%%%%%%%%%%%%%%%%%
% General parameters
%%%%%%%%%%%%%%%%%%%%%%%%%%
chanSep     = 494;                      %channel separation in MHz      
f0          = 8*chanSep;                %center frequency in MHz        
PRF         = chanSep/32;               %Pulse Repetition Frequency     
packetLn    = 32*8;                     %packet length in bits          
txOS        = 8;                        %oversampling factor @ tx       
rxOS        = 8;                        %oversampling factor @ tx       
rxDec       = txOS/rxOS;                %receiver decimation factor    
fs          = chanSep*txOS;             %tx sampling frequency in MHz   
dSF         = 8;                        %spreading factor               
nPulsePerPRF= chanSep/PRF;              %number of pulses per PRF              
nSampsPerPRF= nPulsePerPRF*txOS;        %number of samples per PRF   
nSampsPerBit= nSampsPerPRF*dSF;         %number of samples per bit   
Tc = txOS/fs*1e3; % ns
dt=Tc/txOS;
B=494; % -3 dB
pulseTx = wbaSrrcos(0.25,txOS,8);   %pulse shaping @ Tx      
   


% CHANNELS (CM1)
%%%%%%%%%%%%%%%%%%%%%%%%%%
prep_uwb_chan=0;
if (prep_uwb_chan)
    %
    % wireless uwb channel
    cm = 1;   
    Nchan = 1000;
    H = wbaLDRChan(cm,Nchan,chanSep,fs,f0);
    H=H.';
end

% SIMULATION
sim_det=0;
if (sim_det)
    %
    % SIMULATION PARAMETERS
    %
    % Convolutional code
    cc=poly2trellis([5],[23 35]);
    %
    modulation=3;
    levels=[0,12];
    %
    Nu=1;
    Nbit=packetLn;
    %
    Ntot=10000;
    Nblkerrmax=100;
    %
    asynch=0;
    soft_decode=2;
    Tguard=[0];
    %
    Nlev=30; % 16 + 14 guard
    pnseq=[1,-2,3,-4,-2,3,-5,1];
    [pnseq_bin]=usersig(2,[-1,+1],[1],[1],[1],pnseq,dt,Tc,Nlev);
    %
    % AWGN
    channel=0; 
    order=[1;1];
    Nint_ed=1;
    Esn0=[0:2:12]; % Es/N0
    [nsp,nerr,nerr_ch,nblk,nblk_ch,R]=std_det_4a(det_type,order,modulation,levels,Ebn0,channel,Nbit,Ntot, ...
                                                 Nblkerrmax,pulse,Tc,dt,Nlev,Nu,pnseq,asynch,cc, ...
                                                 soft_decode,pnseq_bin,Nguard,Nint_ed);
    
    channel=H;
    order=[1,5,10;1,5,10];
    Nint_ed=6;
    Esn0=[0:4:24]; % Es/N0
    [nsp,nerr,nerr_ch,nblk,nblk_ch,R]=std_det_4a(det_type,order,modulation,levels,Ebn0,channel,Nbit,Ntot, ...
                                                 Nblkerrmax,pulse,Tc,dt,Nlev,Nu,pnseq,asynch,cc, ...
                                                 soft_decode,pnseq_bin,Nguard,Nint_ed);
    
end
