%===================================================================================
% T  : symbol duration normnalized to one   Os : number of samples per symbol
% N  : bilateral nb of sidelobes            r  : roll-off factor
% t  : time from -N*T:T/Os:N*T              tn : normalized time = t/T
%
%  				        cos[(1+r).pi.tn] + sin[(1-r).pi.tn]/(4.pi.tn)
%							               --------------------------
%			4.r						                 4.pi.tn
% h(t) = ----------- . ----------------------------------------------
%        pi*sqrt(T)                 [1 - (4*r*tn)^2]
%===================================================================================
%Authors    : Ismail Lakkis
%Company    : Wideband Access
%Date       : July 12, 2005
%Verison    : 1
%===================================================================================
function g = wbaSrrcos(r,Os,N);

if (Os == 1),
    g = [1];
else
    %time axis
    T	= 1;Ts = T/Os;t = [-N*Os:N*Os]*Ts + 1e-10;
    %singular points
    idx0 = find(t == 0);t(idx0)= 1e-10;
    idx1 = find(t == 1/(4*r));t(idx1)= 1e-6 + (1/(4*r));
    idx2 = find(t == -1/(4*r));t(idx2) = -1e-6 - 1/(4*r);
    %compute srrcos
    Num = cos((1+r)*pi*t) + ((sin((1-r)*pi*t))./(4*r*t));Den = 1 - ((4*r*t).^2);
    Num(idx0) = 1 + (pi*(1-r)/(4*r));
    %normalization
    g   = (4*r/pi)*(Num./Den);g   = g/sqrt(sum(g.^2));
end;

return;
